//******************************************
// file			: main.c
// version		: V1.0
// brief		: main program
// note			: example of window mode of TCA0
// 				  this example uses timer TCA0 to count when the input signal of P72(TCA0) is low and the unit count length is 1us.
// 				  when TCA0 interrupt ocurs, invert P90 output level
//****************************************** 
#ifndef	IO_MEM
#define	IO_MEM
#endif  
#include "MQ6811.h"
void main()
{
    WDCDR.byte = 0x4e;	//clear WDT   
	   
	   
    P7CR.bit.b2 = 0;
	P9CR.bit.b0 = 1;
	__asm("DI")	;
	POFFCR0.byte = 0x1;
	EIRH.bit.b6 = 1;
	__asm("EI");
	TA0CR.byte = 0x42;//FF=1,no noise canceller,enable auto capture 
	TA0MOD.byte = 0x85;//double buffer,window mode,monitoring H level input in P72(TCA0)
	TA0DRAL.byte = 0x50;//set pulse width
	TA0DRAH.byte = 0x0;
	TA0CR.bit.b0 =1; //start window 
	while(1)
	{	
		WDCDR.byte = 0x4e;	//clear WDT   
	}          
    
}