//******************************************
// file			: main.c
// version		: V1.0
// brief		: main program
// note			: 
//****************************************** 
//******************************************
//Stack Pointer	=	0x23f (If use mq6821_x_startup.asm)
//Ram range = 0x40~0x23f
//******************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif  
#include "MQ6821.h"
#include "MQ6812_REG_BIT.h"

void main()
{
	// programming by IDE : Project -> Pin Setting -> check 'ext low OSC'
	
	P0FC.bit.b0 = 	1;			//P00 switch to External clock Pin
	P0CR.bit.b0 = 	0;			
	P0CR.bit.b1 = 	0;			//P00 P01 input
	FSCTRL.bit.b0 = 1;			// select external low-frequency clock as low-frequency clock source-frequency clock source
		
	SYSCR2.bit.b5	=	1;		// from NORMAL1 mode to NORMAL2 mode	
	SYSCR2.bit.b4	=	1;		// from NORMAL2 mode to SLOW2 mode
	SYSCR2.bit.b7	=	0;		// from SLOW2 mode to SLOW1 mode
	while(1)
	{
		WDCDR.byte = 0x4e;
	}
	
}

