//*************************************************************************************
// file			: SQ7515_TCA0_16BIT_Timer.h
// version		: V3.0
// brief		: TCA0_16BIT_Timer header file [Only TCA0_Timer] 
// note			:        
//**************************************************************************************
#ifndef _SQ7515_TCA_H__
#define _SQ7515_TCA_H__

#define d_10Hz_Count 1171   // 1171*42.6667us = 0.05s, every 0.05s invert P2.4, so frequency is 10Hz
#define d_25Hz_Count 468
#define d_50hz_Count 234

#define TCA_count_scale 42  // 1024/24 = 42.66 

extern unsigned char TCA0_Int_Flag;

void TCA0_Timer_Init();
void TCA0_IntEnable();
void TCA0_SetPeriod(unsigned int period);
void TCA0_Start();
void TCA0_Stop();

void __interrupt IntTCA0(void);

#endif // _SQ7515_TCA_H__