//*************************************************************************************
// file			: SQ7653_PLL_System_Init.h
// version		: V1.0 2020/07/17
// brief		: PLL_System_Init header file
// note			: 
//**************************************************************************************
#ifndef _SQ7653_PLL_System_Init_H__
#define _SQ7653_PLL_System_Init_H__

/* ---------------------- extern global variables ------------------------- */




/* ---------------------- user-defined macros ------------------------------ */
#define PLL_24M    	0x00	// system frequency divided by 1    (24M/1	= 24MHz) 
#define PLL_12M    	0x01	// system frequency divided by 2    (24M/2	= 12MHz) 
#define	PLL_6M  	0x02	// system frequency divided by 4    (24M/4	= 6MHz) 
#define PLL_3M  	0x03	// system frequency divided by 8    (24M/8	= 3MHz) 
#define PLL_1_5M    0x04	// system frequency divided by 16   (24M/16	= 1.5MHz = 1500kHz)
 
#define PLL_750K    0x05	// system frequency divided by 32   (24M/32	= 750kHz) 
#define PLL_375k    0x06	// system frequency divided by 64   (24M/64	= 375kHz) 
#define PLL_187_5K  0x07	// system frequency divided by 128  (24M/128 = 187.5kHz)

//-----------------------------------------------------------------
void PLL_System_Init(unsigned char F_div_sel);
void PLL_Freq_Division(unsigned char F_div_sel);


#endif


