//******************************************************************************
// file         : DRV_SQ7705_TRNG.h
// version      : V1.2 2024/01/05
// description  : TRNG header file
// note         : 
//******************************************************************************
#ifndef _DRV_SQ7705_TRNG_H__
#define _DRV_SQ7705_TRNG_H__

#include "TypeDefs.h"
#include "SQ7705_SFR.h"

//******************************************************************************
// name         : DRV_TRNG_Init()
// description  : TRNG initialization
// input param  : 
// retval       : 
// note         : 
//******************************************************************************
void DRV_TRNG_Init(void);

//******************************************************************************
// name         : DRV_TRNG_DeInit()
// description  : Deinitialize TRNG
// input param  : 
// retval       : 
// note         : 
//******************************************************************************
void DRV_TRNG_DeInit(void);

//******************************************************************************
// name         : DRV_TRNG_Generate()
// description  : generate a 32-bit true random number
// output param : - outputTRNG : 32-bit true random number
// retval       : 
// note         : 
//******************************************************************************
void DRV_TRNG_Generate(uint8_t* outputTRNG);

#endif