//******************************************************************************
// file         : main.h
// version      : V1.2 2023/08/15
// description  : header file of main.c
// note         : 
//******************************************************************************
#ifndef _MAIN_H__
#define _MAIN_H__

/* ---------------------- reference header files ---------------------------- */
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "TypeDefs.h"
#include "SQ7705_SFR.h"
#include "DRV_SQ7705_GPIO.h"


/* ---------------------- user-defined constants ---------------------------- */
#define BTN1_in    DRV_GPIO_ReadPin(GPIO_P50)
#define BTN2_in    DRV_GPIO_ReadPin(GPIO_P51)
#define BTN3_in    DRV_GPIO_ReadPin(GPIO_P52)

#define LED1_on    DRV_GPIO_WritePin(GPIO_P20, GPIO_PIN_LOW)
#define LED2_on    DRV_GPIO_WritePin(GPIO_P21, GPIO_PIN_LOW)
#define LED3_on    DRV_GPIO_WritePin(GPIO_P22, GPIO_PIN_LOW)
#define LED1_off   DRV_GPIO_WritePin(GPIO_P20, GPIO_PIN_HIGH)
#define LED2_off   DRV_GPIO_WritePin(GPIO_P21, GPIO_PIN_HIGH)
#define LED3_off   DRV_GPIO_WritePin(GPIO_P22, GPIO_PIN_HIGH)
#define LED1_to_3_turn_off   LED1_off; LED2_off; LED3_off;

/* ---------------------- extern global variables --------------------------- */





/* ---------------------- extern functions ---------------------------------- */
extern void ADM_STARTUP(void);


#endif //#ifndef _MAIN_H__

